<template>
    <div class="col-md-7">
        <h4 class="my-3">
            Complete los datos siguientes datos para completar su incripción.
        </h4>
        <div
            v-if="error"
            id="errorAlert"
            class="alert alert-danger alert-dismissible fade show"
            role="alert"
        >
            <strong>Ohh no!</strong> {{ error }}.
            <button
                type="button"
                class="close"
                v-on:click.prevent="closeAlert()"
                aria-label="Close"
            >
                <span aria-hidden="true">&times;</span>
            </button>
        </div>
        <div class="form-group mb-4">
            <select v-model="pago.order_id" name="banco" class="form-control">
                <option disabled value=""
                    >Seleccione la orden a registrar pago</option
                >
                <option v-for="item in orders" :key="item.id" :value="item.id">
                    Orden #{{ item.id }}</option
                >
            </select>
        </div>
        <div class="form-group mb-4">
            <select v-model="pago.banco_id" name="banco" class="form-control">
                <option disabled value=""
                    >Seleccione la cuenta a la que realizó la
                    transferencia</option
                >
                <option v-for="item in banco" :key="item.id" :value="item.id">{{
                    item.name_banco
                }}</option>
            </select>
        </div>

        <div class="form-group mb-4">
            <label for="other_bank">Pago interbancario</label>

            <input
                v-model="pago.other_bank"
                name="other_bank"
                id="other_bank"
                type="checkbox"
                class="js-switch-primary"
                value="true"
            />
        </div>
        <div v-if="pago.other_bank" class="form-group mb-4">
            <div class="input-group">
                <div class="input-group-prepend">
                    <span class="input-group-text">Banco</span>
                </div>
                <input
                    type="text"
                    class="form-control"
                    v-model="pago.other_bank_name"
                    placeholder="Ingrese el nombre del banco de origen de la transferencia"
                />
            </div>
        </div>
        <div class="form-group mb-4">
            <input
                type="text"
                class="form-control"
                v-model="pago.referencia"
                placeholder="Referencia bancaria"
            />
        </div>
        <div class="form-group mb-4">
            <input
                type="text"
                class="form-control"
                v-model="pago.nombre"
                placeholder="Nombre y apellido del propietario de la cuenta"
            />
        </div>
        <div class="form-group mb-4">
            <input
                type="text"
                class="form-control"
                v-model="pago.documento"
                placeholder="Documento de identidad ( # Cedula, DNI)"
            />
        </div>
        <div class="form-group mb-4">
            <button
                type="button"
                class="btn btn-primary btn-block"
                data-toggle="modal"
                data-target="#form-payment"
            >
                Procesar pago
            </button>
        </div>
        <div
            class="modal fade"
            id="form-payment"
            tabindex="-1"
            role="dialog"
            aria-labelledby="form-payment"
            aria-hidden="true"
        >
            <div class="modal-dialog" role="document">
                <div class="modal-content">
                    <div class="modal-header bg-warning text-black">
                        <h5 class="modal-title text-black" id="form-payment">
                            Editar cuenta bancaria
                        </h5>
                        <button
                            type="button"
                            class="close"
                            data-dismiss="modal"
                            aria-label="Close"
                        >
                            <span aria-hidden="true">&times;</span>
                        </button>
                    </div>
                    <div class="modal-body">
                        <form
                            v-bind:id="'form-payment'"
                            method="POST"
                            v-on:submit.prevent="submit"
                        >
                            <div
                                v-if="error"
                                id="errorAlert"
                                class="alert alert-danger alert-dismissible fade show"
                                role="alert"
                            >
                                <strong>Ohh no!</strong> {{ error }}.
                                <button
                                    type="button"
                                    class="close"
                                    v-on:click.prevent="closeAlert()"
                                    aria-label="Close"
                                >
                                    <span aria-hidden="true">&times;</span>
                                </button>
                            </div>
                            <div class="form-group">
                                <strong>Alerta!!</strong> El siguiente correo
                                será el asignado para iniciar el curso, en caso
                                de ser incorrecto por favor cambierlo. <br />
                                <em
                                    ><strong
                                        >Recuerde que el mismo no podrá ser
                                        cambiado en un futuro</strong
                                    ></em
                                >
                                <input
                                    type="text"
                                    placeholder="Correo Eletrónico"
                                    class="form-control "
                                    name="name_banco"
                                    required
                                    autocomplete="name_banco"
                                    autofocus
                                    v-model="pago.correo_inscripcion"
                                />
                            </div>
                        </form>
                    </div>
                    <div class="modal-footer">
                        <button
                            type="button"
                            class="btn btn-secondary"
                            data-dismiss="modal"
                        >
                            Close
                        </button>
                        <button
                            v-on:click.prevent="submit"
                            type="button"
                            class="btn btn-primary"
                            :id="'post'"
                        >
                            Guardar cambios
                        </button>
                    </div>
                </div>
            </div>
        </div>
    </div>
</template>

<script>
export default {
    props: ["banco", "order", "auths"],
    mounted() {},
    data() {
        return {
            bancos: this.banco,
            orders: this.order,
            pago: {
                banco_id: "",
                order_id: "",
                other_bank: false,
                other_bank_name: "",
                referencia: "",
                nombre: "",
                documento: "",
                correo_inscripcion: this.auths.email
            },

            error: ""
        };
    },
    methods: {
        submit() {
            console.log(this.pago);
            $("#submit").attr("disabled", true);
            if (
                this.pago.banco_id &&
                this.pago.order_id &&
                this.pago.referencia &&
                this.pago.nombre &&
                this.pago.documento
            ) {
                if (
                    Number.isInteger(Number(this.pago.referencia)) &&
                    Number.isInteger(Number(this.pago.documento))
                ) {
                    if (this.pago.other_bank) {
                        if (this.pago.other_bank_name) {
                            axios
                                .post(
                                    "/api/accounting/payment/transferencias",
                                    this.pago
                                )
                                .then(res => {
                                    location.href = "/dashboard";
                                });
                        } else {
                            $("#submit").attr("disabled", false);
                            this.error =
                                "Ha seleccionado transferencia interbancario, debe indicar el nombre del banco del que hizo la referencia";
                        }
                    } else {
                        axios
                            .post(
                                "/api/accounting/payment/transferencias",
                                this.pago
                            )
                            .then(res => {
                                location.href = "/dashboard";
                            });
                    }
                } else {
                    $("#submit").attr("disabled", true);
                    this.error =
                        "Los campos de referencia y documento deben ser valores numericos";
                }
            } else {
                $("#submit").attr("disabled", true);
                this.error =
                    "Debe completar todos los campos necesarios para continuar";
            }
        },
        closeAlert: function() {
            this.error = "";
        }
    }
};
</script>
